
	\section{Notes from Chapter 3: Programming MCDRAM and Cluster modes}
	\paragraph{Usage model} The usage models available are dependent upon which memory and cluster modes where set at boot time. (p.25)
	
	\paragraph{Programming for cluster modes} It is very important to know that, regardless of the cluster mode selected, all of memory, DDR and MCDRAM, is always available to every core. Also, all memory is fully cache coherent. This means that every core has the same view of what data is in every location. What differs between the modes is whether the view of a particular memory (DDR or MCDRAM) from the cores is UMA (Uniform Memory Access) or NUMA (Non-Uniform Memory Access). In any case, even if MCDRAM and DDR are each used as UMA memory, the combination is NUMA. (p. 26)
	
	There are five cluster modes which are often thought of as three modes with two variations: all-to-all, quadrant (variation: hemisphere), and SNC-4 (variation: SNC-2). (p. 26)
	
	The default cluster mode is quadrant unless you have a machine where the DDR is not evenly populated. If the DDR DIMMs connected to the Knights Landing are not equal in capacity, then the only cluster mode available is the all-to-all mode. The cluster modes, other than all-to-all, optimize internal tables of the Knights Landing assuming evenly populated DDR DIMMs. (p.26)
	
	In quadrant mode, each memory type is UMA meaning that the latency from any given core to any memory location within the same memory type (MCDRAM or DDR) is essentially the same. (p. 27)
	
	In SNC-4, each memory type is NUMA meaning that the cores and memories are divided into (four) quadrants and higher latency for ``far'' (within a different quadrant) memory accesses. SNC-4 is well suited for MPI applications that utilize four, or a multiple of four, ranks per Knight Landing. (p. 27)
	
	The other two cluster modes, that are often called as variations on quadrant and SNC-4, are hemisphere and SNC-2. These two modes are identical to quadrant and SNC-4, except they logically divide the cores and memory (by types) into halves instead of quarters. These two-way modes have higher latency that leads to reduced bandwidth as a result. They may be a better fit for the way a particular application is structured or the number of active tiles does not divide by four. (p. 27)
	
	\paragraph{Programming for memory modes} See Table \ref{tab:memory-modes}. (p. 28)
	
	\begin{table}
		\centering
		\begin{tabu}{l|X|X}
			\textbf{Memory mode} & \textbf{MCDRAM} & \textbf{DDR} \\ \hline \hline
			Cache & 100 \% cache (caches DDR data) & Memory (DDR is required in this mode) \\ \hline
			Flat & All used as memory (0\% as cache) & Memory (if present) \\ \hline
			Hybrid & Partitioned as cache (25\% or 50\%) and memory (75\% or 50\%) & Memory (DDR is required in this mode) \\ \hline
		\end{tabu}
		\caption{Modes of the memory in the Knights Landing processor.}
		\label{tab:memory-modes}
	\end{table}
	
	\paragraph{Performance implications of allocation and threading} For the best performance, allocating memory for threads should be done carefully to ensure memory is allocated ``near'' to the work. We can imagine a master thread in an application that allocates and initializes all the memory for the process and then lets the thread pools work on that memory. If the master thread and the worker threads reside in different NUMA modes, then they will have sub-optimal performance. (p. 47)
	
	\paragraph{Allocation with SNC} Because modern operating systems use an allocation-on-demand strategy to assign physical to virtual addresses only when accessed, some considerations will help performance. For optimal performance data should be allocated and first touched by code running on NUMA node which will use the particular data the most. This warrants extra thought if memory is allocated, used, freed and reallocated by a central memory allocator. (p. 47)